unit NewWebBrowser;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, OleCtrls, SHDocVw,
  ComCtrls,mshtml,Variants,ActiveX,StdCtrls,ExtCtrls;

type
  TNewWebBrowser = class(TWebBrowser)
  private
     procedure SetHtml(Value: WideString);
     Function  GetHtml:WideString;
     Function  GetText:WideString;
     procedure SetDesignMode(Value: Boolean);
     Function  GetDesignMode:Boolean;
    { Private declarations }
  protected
    { Protected declarations }
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    { Public declarations }
  published
     property  Html:WideString read GetHtml write SetHtml;
     property  Text:WideString read GetText;
     property  DesignMode:Boolean read GetDesignMode write SetDesignMode Default False;
    { Published declarations }
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('MyLib', [TNewWebBrowser]);
end;

constructor TNewWebBrowser.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  Self.Navigate('about:blank');
end;

destructor TNewWebBrowser.Destroy;
begin
  inherited Destroy;
end;


procedure TNewWebBrowser.SetHtml(Value: WideString);
var
  vv: Variant;
  HTMLDocument: IHTMLDocument2;
begin
  vv := VarArrayCreate([0, 0], varVariant);
  vv[0] := Value;
  HTMLDocument := Self.Document as IHTMLDocument2;
  HTMLDocument.write(pSafearray(TVarData(vv).VArray));
  HTMLDocument.close;
end;

Function TNewWebBrowser.GetHtml:WideString;
var
  vv: Variant;
  HTMLDocument: IHTMLDocument2;
begin
  vv := VarArrayCreate([0, 0], varVariant);
  HTMLDocument := Self.Document as IHTMLDocument2;
  Result:=HTMLDocument.body.outerHTML;
  HTMLDocument.close;
end;

Function TNewWebBrowser.GetText:WideString;
var
  vv: Variant;
  HTMLDocument: IHTMLDocument2;
begin
  vv := VarArrayCreate([0, 0], varVariant);
  HTMLDocument := Self.Document as IHTMLDocument2;
  Result:=HTMLDocument.body.outerText;
  HTMLDocument.close;
end;

procedure TNewWebBrowser.SetDesignMode(Value: Boolean);
var
  HTMLDocument: IHTMLDocument2;
begin
  HTMLDocument := Self.Document as IHTMLDocument2;
  if Value then
    HTMLDocument.designMode:='On'
  else
    HTMLDocument.designMode:='Off';
  HTMLDocument.close;
end;

Function TNewWebBrowser.GetDesignMode;
var
  HTMLDocument: IHTMLDocument2;
begin
  HTMLDocument := Self.Document as IHTMLDocument2;
  if HTMLDocument.designMode='On' then
    Result:=True
  else
    Result:=False;
  HTMLDocument.close;
end;

end.
